﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Storage;
using System.IO;
using System.Xml.Serialization;
using Cursed.gob;

namespace Cursed
{
    public class SaveUtil
    {
        public static bool operationPending = false;
        static CursedGame game;
        private static List<GobInfo> gobs;

        public void Save(CursedGame game)
        {
            SaveUtil.game = game;
            operationPending = true;
            Guide.BeginShowStorageDeviceSelector(FindStorageDevice, "saveRequest");
        }

        public List<GobInfo> Load()
        {
            operationPending = true;
            Guide.BeginShowStorageDeviceSelector(FindStorageDevice, "loadRequest");
            return gobs;

        }

        private void FindStorageDevice(IAsyncResult result)
        {
            StorageDevice storageDevice = Guide.EndShowStorageDeviceSelector(result);
            if (storageDevice != null)
            {
                if (result.AsyncState == "saveRequest")
                    SaveGame(storageDevice);
                else if (result.AsyncState == "loadRequest")
                    LoadGame(storageDevice);
            }
        }



        private void LoadGame(StorageDevice storageDevice)
        {
            StorageContainer container = storageDevice.OpenContainer("Cursed!");
            string fileName = Path.Combine(container.Path, "save0001.sav");
            if (File.Exists(fileName))
            {
                FileStream saveFile = File.Open(fileName, FileMode.Open);
                XmlSerializer xmlSerializer = new XmlSerializer(typeof(List<GobInfo>));

                gobs = (List<GobInfo>)xmlSerializer.Deserialize(saveFile);
                saveFile.Close();
                operationPending = false;
            }
            container.Dispose();
        }

        private void SaveGame(StorageDevice storageDevice)
        {
            StorageContainer container = storageDevice.OpenContainer("Cursed!");
            string fileName = Path.Combine(container.Path, "save0001");

            FileStream saveFile = File.Open(fileName, FileMode.Create);

            XmlSerializer xmlSerializer = new XmlSerializer(typeof(List<GobInfo>));
            xmlSerializer.Serialize(saveFile, game);
            saveFile.Close();
            container.Dispose();
            operationPending = false;
        }
    }
}
