﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.input.ai;
namespace Cursed.gob.mob.kob
{
    public class FamiliarInfo : DemonInfo
    {
        public FamiliarInfo()
            : base()
        {
            AccMag = 5;
            Depth = Const.FamiliarDepth;
            Mass = .1f;
        }

        public override Gob create(CursedGame game)
        {
            return new Familiar(game, this);
        }
    }

    class Familiar: Demon
    {
        public Familiar(CursedGame game, FamiliarInfo info)
            : base(game, info)
        {
            renderInfo.Mask = Microsoft.Xna.Framework.Graphics.Color.White;
            info.SpinAttack = true;
            info.Lunge = true;
            sightSound = "Friendly Spirit\\roarSound";
        }
        protected override void addControllers()
        {
            LifeSeeker seekerControl = new LifeSeeker(this);
            CursedGame.AddController(seekerControl);
            seekerControl.Push(this);

            SpiritAttacker attackControl = new SpiritAttacker(this);
            CursedGame.AddController(attackControl);
            attackControl.Push(this);
        }

        public FamiliarInfo FamiliarInfo
        {
            get { return (FamiliarInfo)info; }
        }
        public override void updateColor()
        {
            
            return;
        }
    }
}
