﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using System.Runtime.Serialization;

namespace Cursed.gob.tile
{
    public class GroundInfo : TileInfo
    {
        // the resistance this ground has to things walking over it
        float drag;
        // the purchase this ground provides to things walking over it
        float friction;

        public GroundInfo(int x, int y)
            : base(x, y)
        {
            drag = 2;
            friction = 1;
            Depth = Const.GroundDepth;
        }

        public override Gob create(CursedGame game)
        {
            return new Ground(game, this);
        }

        public float Drag
        {
            get { return drag; }
            set { drag = value; }
        }

        public float Friction
        {
            get { return friction; }
            set { friction = value; }
        }
    }
    public class Ground : Tile
    {
        public Ground(CursedGame game, GroundInfo info)
            : base(game, info)
        {
            //renderInfo.Mask = new Color(106, 106, 82);
            renderInfo.Mask = Color.White;
            renderInfo.Texture = CursedGame.textureLib.GetTexture("crackedGround");
            Transcendent = true;
        }

        public GroundInfo GroundInfo
        {
            get { return (GroundInfo)info; }
        }
    }
}
