﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using System.Windows.Media;
using Cursed.view;
using Cursed.geom;
using System.Runtime.Serialization;
using Cursed.view.renders;

namespace Cursed.gob.tile
{
    public class TileInfo : GobInfo
    {
        int x, y;

        public TileInfo(int x, int y)
            : base()
        {
            this.x = x;
            this.y = y;
            Loc = new Vector2(x, y);
        }

        public int X
        {
            get { return x; }
        }
        public int Y
        {
            get { return y; }
        }
    }

    public class Tile : Gob
    {
        protected RenderInfo renderInfo;

        public Tile(CursedGame game, TileInfo info)
            : base(game, info)
        {
            shape = new Rect(Vector2.Zero, 1, 1);
            shape.setTransform(TileInfo.Loc, 0, 1);
            renderInfo = new SpriteRenderInfo(Bounds);
            renderInfo.Texture = CursedGame.textureLib.GetTexture("square");
            renderInfo.Transform = Microsoft.Xna.Framework.Matrix.Identity;
            addRender(game.getRender(Cursed.view.renders.Render.RenderType.SpriteRender), renderInfo);

            renderInfo.Mask = Microsoft.Xna.Framework.Graphics.Color.Yellow;
        }

        public int X
        {
            get { return ((TileInfo)info).X; }
        }

        public int Y
        {
            get { return ((TileInfo)info).Y; }
        }

        public TileInfo TileInfo
        {
            get { return (TileInfo)info; }
        }
    }
}
