﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using System.Runtime.Serialization;
using Cursed.geom;

namespace Cursed.gob.tile
{
    public class WallInfo : TileInfo
    {
        public WallInfo(int x, int y)
            : base(x, y)
        {
            Depth = Const.WallDepth;
        }

        public override Gob create(CursedGame game)
        {
            return new Wall(game, this);
        }
    }

    public class Wall : Tile
    {
        public Wall(CursedGame game, WallInfo info)
            : base(game, info)
        {
            Rect r = (Rect)Shape;
            r.CanPushUp = false;
            r.CanPushDown = false;
            renderInfo.Mask = new Color(88, 102, 50);
            Transcendent = false;
        }

        public GroundInfo GroundInfo
        {
            get { return (GroundInfo)info; }
        }
    }
}
