﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Cursed.input
{
    public class ControlInfo
    {

    }


    public enum MouseType
    {
        None,
        Offensive,
        Defensive
    }

    public class MouseCursorInfo : ControlInfo
    {
        Vector2 mouse;
        bool clicked;
        MouseType type;

        public Vector2 Mouse
        {
            get { return mouse; }
            set { mouse = value; }
        }

        public bool Clicked
        {
            get { return clicked; }
            set { clicked = value; }
        }

        public MouseType Type
        {
            get { return type; }
            set { type = value; }
        }
    }

    public class MouseTrailInfo : ControlInfo
    {

        List<Vector2> trail;
        MouseType type;
        bool finished;

        public MouseTrailInfo()
        {
            trail = new List<Vector2>();
            type = MouseType.None;
            finished = false;
        }

        public List<Vector2> Trail
        {
            get { return trail; }
        }

        public MouseType Type
        {
            get { return type; }
            set { type = value; }
        }

        public bool Finished
        {
            get { return finished; }
            set { finished = value; }
        }
    }

    public class DirectionControlInfo : ControlInfo
    {
        Vector2 direction;

        public Vector2 Direction
        {
            get { return direction; }
            set { direction = value; }
        }
    }

    public class EscapeControlInfo : ControlInfo
    {

    }

    public class BasicAttackInfo : ControlInfo
    {
        public enum ATTACKTYPE{NORMAL,SPIN,SLAM};
        Vector2 direction;
        ATTACKTYPE type;
        public BasicAttackInfo()
        {
            type = ATTACKTYPE.NORMAL;
        }
        public Vector2 Direction
        {
            get { return direction; }
            set { direction = value; }
        }
        public ATTACKTYPE Type
        {
            get{return type;}
            set { type = value; }
        }
    }
}
