﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;

namespace Cursed.input
{
    class KeyDirectionController : Controller
    {
        bool up;
        bool down;
        bool left;
        bool right;

        void getKeys()
        {
            KeyboardState keyState = Keyboard.GetState();
            up = keyState[Keys.W] == KeyState.Down;
            left = keyState[Keys.A] == KeyState.Down;
            down = keyState[Keys.S] == KeyState.Down;
            right = keyState[Keys.D] == KeyState.Down;
        }
        public override void act(GameTime time)
        {
            getKeys();
            DirectionControlInfo info = new DirectionControlInfo();
            if (up)
            {
                info.Direction += Vector2.UnitY;
            }
            if (down)
            {
                info.Direction -= Vector2.UnitY;
            }
            if (right)
            {
                info.Direction += Vector2.UnitX;
            }
            if (left)
            {
                info.Direction -= Vector2.UnitX;
            }
            if (info.Direction != Vector2.Zero)
            {
                Vector2 dir = info.Direction;
                dir.Normalize();
                info.Direction = dir;
            }
            if (Target != null)
            {
                Target.control(info);
            }
        }

        public override void cleanup()
        {
            throw new NotImplementedException();
        }
    }
}
