﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Cursed.view;
using Microsoft.Xna.Framework.Input;

namespace Cursed.input
{
    public class MouseTrailController : MouseController
    {
        MouseTrailInfo info;

        public MouseTrailController(OrthoCamera camera, GameWindow window)
            : base(camera, window)
        {
            info = new MouseTrailInfo();
        }


        public override void act(GameTime time)
        {
            getMousePos();

            if (info.Type == MouseType.None)
            {
                if (Mouse.GetState().LeftButton == ButtonState.Pressed)
                {
                    info.Type = MouseType.Offensive;
                    info.Trail.Clear();
                }
                else if (Mouse.GetState().RightButton == ButtonState.Pressed)
                {
                    info.Type = MouseType.Defensive;
                    info.Trail.Clear();
                }
            }

            if (info.Type == MouseType.Offensive)
            {
                if (Mouse.GetState().LeftButton == ButtonState.Released)
                {
                    info.Finished = true;
                }
                else
                {
                    info.Trail.Add(CurrentMousePosition);
                }
            }

            if (info.Type == MouseType.Defensive)
            {
                if (Mouse.GetState().RightButton == ButtonState.Released)
                {
                    info.Finished = true;
                }
                else
                {
                    info.Trail.Add(CurrentMousePosition);
                }
            }

            if (Target != null)
                Target.control(info);

            if (info.Finished)
            {
                /*
                System.Console.WriteLine("Trail type " + info.Type);
                foreach (Vector2 pos in info.Trail)
                {
                    System.Console.WriteLine(pos);
                }
                 */
                info = new MouseTrailInfo();
                
            }
        }
    }
}
