﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.gob.mob;
using Microsoft.Xna.Framework;
using Cursed.gob;
using Cursed.gob.mob.kob;

namespace Cursed.input.ai
{
    public class DruidSeeker : Controller
    {
        Demon demon;
        Vector2 dir;
        public DruidSeeker(Demon mob)
        {
            this.demon = mob;
            dir = Vector2.Zero;
        }
        public override void act(Microsoft.Xna.Framework.GameTime time)
        {
            DirectionControlInfo info = new DirectionControlInfo();
            //if (demon.CursedGame.Random.NextDouble() < .01)
            //    dir = new Vector2((float)demon.CursedGame.Random.NextDouble() - .5f, (float)demon.CursedGame.Random.NextDouble() - .5f) * .5f;
            info.Direction = dir;

            if (demon.Goal == null)
            {
                foreach (Mob mob in demon.SeenMobs)
                {
                    if (mob is Druid)
                    {
                        Vector2 offset = mob.GobInfo.Loc - demon.MobInfo.Loc;
                        offset.Normalize();
                        info.Direction = offset;
                        demon.Goal = mob;
                    }
                }
            }
            else
            {
                if (demon.SeenMobs.Contains(demon.Goal))
                {
                    Vector2 offset = demon.Goal.GobInfo.Loc - demon.MobInfo.Loc;
                    offset.Normalize();
                    info.Direction = offset;
                }
                else
                {
                    demon.Goal = null;
                }
            }
            if (Target != null)
            {
                Target.control(info);
            }
        }

        public override void cleanup()
        {

        }
    }
}
