﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Cursed.gob.mob.kob;
using Cursed.gob.mob;
using Cursed.gob;

namespace Cursed.input.ai
{
    class LifeSeeker : Controller
    {
        Familiar fmr;
        public LifeSeeker(Familiar fmr)
        {
            this.fmr = fmr;
        }
        public override void act(Microsoft.Xna.Framework.GameTime time)
        {
            DirectionControlInfo info = new DirectionControlInfo();
            info.Direction = Vector2.Zero;
            if (fmr.Goal == null)
            {
                Mob temp = null;
                float distSqrd = -1;
                foreach (Mob m in fmr.SeenMobs)
                {
                    if ((m is Demon) && (m != fmr) && ((Demon)m).DemonInfo.Energy > -1f)
                    {
                        float nextdist = (m.Loc - fmr.Loc).LengthSquared();
                        if (distSqrd == -1 || nextdist < distSqrd)
                        {
                            distSqrd = nextdist;
                            temp = m;
                           
                        }
                        
                    }
                    
                        
                }
                if (temp != null)
                {
                    
                    info.Direction = (temp.Loc - fmr.Loc);
                    fmr.Goal = (Demon)temp;                   
                    info.Direction.Normalize();
                }
                else
                {
                    float size = 0;
                    Vector2 pos = Vector2.Zero;
                    foreach (Mob m in fmr.SeenMobs)
                    {
                        if ((m is LifeBlob))
                        {
                            pos += m.Loc * ((LifeBlob)m).LifeInfo.Amount;
                            size += ((LifeBlob)m).LifeInfo.Amount;
                        }
                    }
                    if (size > 0)
                    {
                        pos/= size;
                        info.Direction = (pos-fmr.Loc);
                        info.Direction.Normalize();
                        
                        //don't walk into the druid
                        foreach (Gob gb in fmr.SeenMobs)
                        {
                            if (gb is Druid && 
                                (gb.GobInfo.Loc-fmr.Loc).LengthSquared()<
                                .8*(((Druid)gb).DruidInfo.Scale+fmr.FamiliarInfo.Scale))
                            {
                               

                                float x = info.Direction.X;
                                float y = info.Direction.Y;
                                info.Direction = new Vector2(y, -x);

                                //info.Direction -= normal;
                                info.Direction.Normalize();
                            }
                        }
                    }
                    if (Target != null)
                    {
                        Target.control(info);
                    }
                }
            }
            else if (!fmr.SeenMobs.Contains(fmr.Goal) || ((Demon)fmr.Goal).DemonInfo.Energy<=-1f)
            {
                fmr.Goal = null;
            }
            else
            {
                info.Direction = (fmr.Goal.Loc - fmr.Loc);
                info.Direction.Normalize();
            }
            if (Target != null)
            {
                Target.control(info);
            }
        }
        public override void cleanup()
        {
           
        }
    }
}
