using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Cursed.sound
{
    //Stores the wave files so we do not have
    //redundant files in memory.
    public class SoundBank
    {
        Dictionary<string, SoundEffect> sounds;
        ContentManager content;
        public SoundBank(ContentManager content)
        {
            this.content = content;
            sounds = new Dictionary<string, SoundEffect>();
        }
        public void loadSound(string name)
        {
            sounds.Add(name, content.Load<SoundEffect>("Sounds\\"+name));
        }
        public SoundEffectInstance getInstance(string name)
        {
            try
            {
                return sounds[name].CreateInstance();
            }
            catch (KeyNotFoundException)
            {
                loadSound(name);
            }
            return sounds[name].CreateInstance();

        }
    }
}
